'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _EventObj = require('./EventObj');

var _EventObj2 = _interopRequireDefault(_EventObj);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Reactor = function () {
  function Reactor() {
    _classCallCheck(this, Reactor);

    this.events = {};
  }

  _createClass(Reactor, [{
    key: 'registerEvent',
    value: function registerEvent(eventName) {
      var event = new _EventObj2.default(eventName);
      this.events[eventName] = event;
    }
  }, {
    key: 'dispatchEvent',
    value: function dispatchEvent(eventName, eventArgs) {
      for (var c in this.events[eventName].callbacks) {
        this.events[eventName].callbacks[c](eventArgs);
      }
    }
  }, {
    key: 'addEventListener',
    value: function addEventListener(eventName, callback) {
      this.events[eventName].registerCallback(callback);
    }
  }, {
    key: 'removeEventListeners',
    value: function removeEventListeners(eventName) {
      this.events[eventName].removeCallbacks();
    }
  }]);

  return Reactor;
}();

exports.default = Reactor;